////////////////////////////////////////////////////////////////////////
// cookie.cpp
// generated with ecppc
// date: Fri Apr 25 11:20:35 2008
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.cookie")

// <%pre>
// </%pre>

namespace
{
template <typename T> inline void use(const T&) { }

class _component_cookie : public tnt::EcppComponent
{
    _component_cookie& main()  { return *this; }

  protected:
    ~_component_cookie();

  public:
    _component_cookie(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_cookie> cookieFactory("cookie");

static const char* rawData = "\024\000\000\000\025\000\000\000\211\000\000\000\327\000\000\000W\001\000\000\n<html>\n <head>\n  <title>Hello World-application for tntnet</title>\n </head>\n\n <body bgcolor=\"#FFFFFF\">\n\n  <h1>Hello </h1>\n\n  <form>\n   What's your name\?\n   <input type=\"text\" name=\"name\" value=\"\"> <br>\n   <input type=\"submit\">\n   <input type=\"submit\" name=\"clearcookie\" value=\"delete cookie\">\n  </form>\n\n </body>\n</html>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_cookie::_component_cookie(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_cookie::~_component_cookie()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_cookie::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);

  // <%args>
std::string name = qparam.param("name");
std::string clearcookie = qparam.param("clearcookie");
  // </%args>

  // <%cpp>
  reply.out() << data[0]; // \n
#line 12 "cookie.ecpp"


  if (name.empty())
    name = request.getCookie("name");

  if (!clearcookie.empty())

    reply.clearCookie("name");   // delete cookie from client

  else if (!name.empty() && request.getCookie("name").getValue() != name)

    reply.setCookie("name", name, 3600);  // set cookie when new or modified


  reply.out() << data[1]; // <html>\n <head>\n  <title>Hello World-application for tntnet</title>\n </head>\n\n <body bgcolor="#FFFFFF">\n\n  <h1>Hello 
#line 33 "cookie.ecpp"
  reply.sout() << ( name.empty() ? "World" : name );
  reply.out() << data[2]; // </h1>\n\n  <form>\n   What's your name\?\n   <input type="text" name="name" value="
#line 37 "cookie.ecpp"
  reply.sout() << (name);
  reply.out() << data[3]; // "> <br>\n   <input type="submit">\n   <input type="submit" name="clearcookie" value="delete cookie">\n  </form>\n\n </body>\n</html>\n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace

